export declare class RegexCompiler {
    readonly rawRegex: string;
    readonly expandedRegex: string;
    private graphJson;
    private nodeCount;
    private outgoingNodes;
    private incomingNodes;
    private incomingStringNodes;
    private initialState;
    private acceptState;
    stringRegexCircuit: string;
    constructor(rawRegex: string, logsEnabled?: boolean);
    static initialize(rawRegex: string, logsEnabled?: boolean): RegexCompiler;
    private sortNodes;
    private writeDeclarationLines;
    private writeInitLines;
    private writeBodyLines;
    private writeAcceptLines;
    extractSubPatternTransitions(partRegexArray: string[]): [number, number][][];
    private generateRevealLines;
    private writeRevealLines;
    generateStringRegexCircuit(countEnabled: boolean, revealEnabled: boolean, transitionInput?: string[] | [number, number][][], functionName?: string): void;
    printRegexCircuit(stringRegexCircuit?: string): void;
}
