"use strict";
class NFA {
    constructor(startState, acceptingStates) {
        this.startState = startState;
        this.acceptingStates = acceptingStates;
    }
}
class DFA {
    constructor(startState, states) {
        this.startState = startState;
        this.states = states;
    }
}
function regexToDFA(regex) {
    // Parsing regex and constructing NFA
    // This part is complex and requires a regex parser
    // Converting NFA to DFA
    // This part also requires conversion algorithms
    // Generating DFA graph representation
    // This would involve creating a graph from DFA states and transitions
    // For simplicity, return a dummy DFA
    const startState = { name: 'q0', transitions: {} };
    const state1 = { name: 'q1', transitions: {} };
    const state2 = { name: 'q2', transitions: {} };
    const acceptingState = { name: 'q3', transitions: {} };
    startState.transitions['0'] = [state1];
    state1.transitions['1'] = [state2];
    state2.transitions['2'] = [acceptingState];
    return new DFA(startState, [startState, state1, state2, acceptingState]);
}
// Example usage
const regex = "1=(a|b) (2=(b|c)+ )+d"; // Example regex
const dfa = regexToDFA(regex);
console.log(dfa);
console.log('states num: ', dfa.states.length);
// const re = /ab+c/i; // literal notation
// OR
const re = new RegExp("ab+c", "i"); // constructor with string pattern as first argument
// OR
// const re = new RegExp(/ab+c/, "i"); // constructor with regular expression literal as first argument
const str = 'table football';
const regexExp = new RegExp('foo*');
const globalRegexExp = new RegExp('foo*', 'g');
console.log(regexExp.test(str));
// Expected output: true
console.log(globalRegexExp.lastIndex);
// Expected output: 0
console.log(globalRegexExp.test(str));
// Expected output: true
console.log(globalRegexExp.lastIndex);
// Expected output: 9
console.log(globalRegexExp.test(str));
// Expected output: false
let regexpEmail = new RegExp('^[a-z0-9._%+-]+@[a-z0-9.-]+.[a-z]{2,4}$');
const isValid = regexpEmail.test('marco@expertcodebolg.com');
console.log('is valid email: ', isValid);
// expected output: true
const isNotValid = regexpEmail.test('marcoexpertcodebolg.com');
// expected output: false
console.log('email is not valid: ', isNotValid);
//# sourceMappingURL=regex.js.map