var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Bool, Field, SmartContract, state, State, method, Bytes, Poseidon, PublicKey, Provable, Mina, PrivateKey, AccountUpdate, UInt8, } from 'o1js';
class Bytes16 extends Bytes(16) {
}
export class RegexZkApp extends SmartContract {
    constructor() {
        super(...arguments);
        this.secretAdmin = State();
        this.isDiscovered = State();
        this.mysterySolver = State();
    }
    async initalize(adminName) {
        super.init();
        this.secretAdmin.set(Poseidon.hash(adminName.toFields()));
        this.isDiscovered.set(Bool(false));
        this.mysterySolver.set(PublicKey.empty());
    }
    async guessName(statement) {
        // This regex pattern specifies an alphabetic name of length 4 where the first letter is capitalized
        let { out, reveal } = nameRegex(statement.bytes);
        out.assertEquals(1, 'Please enter only one valid name!');
        const name = reveal[0];
        const calualtedId = Poseidon.hash(name);
        const adminCheck = this.secretAdmin
            .getAndRequireEquals()
            .equals(calualtedId);
        this.isDiscovered.set(adminCheck);
        const solverAddress = Provable.if(adminCheck, this.sender.getAndRequireSignature(), PublicKey.empty());
        this.mysterySolver.set(solverAddress);
        //? Add payment logic for the first mystery solver
    }
    async benchmark(statement) {
        // This regex pattern specifies an alphabetic name of length 4 where the first letter is capitalized
        let { out, reveal } = bodyHashRegex2(statement.bytes);
        out.assertEquals(Bool(true), 'Please enter only one valid name!');
        // const name = reveal[0];
        // const calualtedId = Poseidon.hash(name);
        // const adminCheck = this.secretAdmin.getAndRequireEquals().equals(calualtedId);
        // this.isDiscovered.set(adminCheck);
        // const solverAddress: PublicKey = Provable.if(
        //     adminCheck,
        //     this.sender.getAndRequireSignature(),
        //     PublicKey.empty()
        // );
        // this.mysterySolver.set(solverAddress);
        // //? Add payment logic for the first mystery solver
    }
}
__decorate([
    state(Field),
    __metadata("design:type", Object)
], RegexZkApp.prototype, "secretAdmin", void 0);
__decorate([
    state(Bool),
    __metadata("design:type", Object)
], RegexZkApp.prototype, "isDiscovered", void 0);
__decorate([
    state(PublicKey),
    __metadata("design:type", Object)
], RegexZkApp.prototype, "mysterySolver", void 0);
__decorate([
    method,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Bytes16]),
    __metadata("design:returntype", Promise)
], RegexZkApp.prototype, "initalize", null);
__decorate([
    method,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Bytes16]),
    __metadata("design:returntype", Promise)
], RegexZkApp.prototype, "guessName", null);
__decorate([
    method,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Bytes16]),
    __metadata("design:returntype", Promise)
], RegexZkApp.prototype, "benchmark", null);
const proofsEnabled = false;
const Local = await Mina.LocalBlockchain({ proofsEnabled });
Mina.setActiveInstance(Local);
const [deployerAccount, senderAccount] = Local.testAccounts;
const zkAppPrivateKey = PrivateKey.random();
const zkAppAddress = zkAppPrivateKey.toPublicKey();
const zkAppInstance = new RegexZkApp(zkAppAddress);
if (proofsEnabled)
    await RegexZkApp.compile();
const deployTxn = await Mina.transaction(deployerAccount, async () => {
    AccountUpdate.fundNewAccount(deployerAccount);
    await zkAppInstance.deploy();
    await zkAppInstance.initalize(Bytes16.fromString('Bart'));
});
await deployTxn.prove();
await deployTxn.sign([zkAppPrivateKey, deployerAccount.key]).send();
const tx = await Mina.transaction(senderAccount, async () => {
    const guess = Bytes16.fromString('Bart the great!');
    await zkAppInstance.guessName(guess);
});
await tx.prove();
await tx.sign([senderAccount.key]).send();
console.log('guessName method rows: ', (await RegexZkApp.analyzeMethods({ printSummary: false }))['guessName'].rows);
console.log('benchmark method rows: ', (await RegexZkApp.analyzeMethods({ printSummary: false }))['benchmark'].rows);
console.log('Admin name is discovered: ', zkAppInstance.isDiscovered.get().toBoolean());
// "[A-Z][a-z][a-z][a-z]" & revealing all
// Basically, the regex pattern is to give an alphabetic name of length 4 where the first letter is capital
function nameRegex(input) {
    const num_bytes = input.length;
    let states = Array.from({ length: num_bytes + 1 }, () => []);
    let state_changed = Array.from({ length: num_bytes }, () => Bool(false));
    states[0][0] = Bool(true);
    for (let i = 1; i < 5; i++) {
        states[0][i] = Bool(false);
    }
    for (let i = 0; i < num_bytes; i++) {
        const lt0 = new UInt8(65).lessThanOrEqual(input[i]);
        const lt1 = input[i].lessThanOrEqual(90);
        const and0 = lt0.and(lt1);
        const and1 = states[i][0].and(and0);
        states[i + 1][1] = and1;
        state_changed[i] = state_changed[i].or(states[i + 1][1]);
        const lt2 = new UInt8(97).lessThanOrEqual(input[i]);
        const lt3 = input[i].lessThanOrEqual(122);
        const and2 = lt2.and(lt3);
        const and3 = states[i][1].and(and2);
        states[i + 1][2] = and3;
        state_changed[i] = state_changed[i].or(states[i + 1][2]);
        const and4 = states[i][2].and(and2);
        states[i + 1][3] = and4;
        state_changed[i] = state_changed[i].or(states[i + 1][3]);
        const and5 = states[i][3].and(and2);
        states[i + 1][4] = and5;
        state_changed[i] = state_changed[i].or(states[i + 1][4]);
        states[i + 1][0] = state_changed[i].not();
    }
    let final_state_sum = [];
    final_state_sum[0] = states[0][4].toField();
    for (let i = 1; i <= num_bytes; i++) {
        final_state_sum[i] = final_state_sum[i - 1].add(states[i][4].toField());
    }
    const out = final_state_sum[num_bytes];
    const msg_bytes = num_bytes - 1;
    const is_consecutive = Array.from({ length: num_bytes }, () => []);
    is_consecutive[msg_bytes][1] = Bool(true);
    for (let i = 0; i < msg_bytes; i++) {
        is_consecutive[msg_bytes - 1 - i][0] = states[num_bytes - i][4]
            .and(is_consecutive[msg_bytes - i][1].not())
            .or(is_consecutive[msg_bytes - i][1]);
        is_consecutive[msg_bytes - 1 - i][1] = state_changed[msg_bytes - i].and(is_consecutive[msg_bytes - 1 - i][0]);
    }
    // revealed transitions: [[[0,1],[1,2],[2,3],[3,4]]]
    let reveal = [];
    // the 0-th substring transitions: [[0,1],[1,2],[2,3],[3,4]]
    const is_reveal0 = [];
    let is_substr0 = Array.from({ length: msg_bytes }, () => []);
    const reveal0 = [];
    for (let i = 0; i < msg_bytes; i++) {
        is_substr0[i][0] = Bool(false);
        is_substr0[i][1] = is_substr0[i][0].or(states[i + 1][0].and(states[i + 2][1]));
        is_substr0[i][2] = is_substr0[i][1].or(states[i + 1][1].and(states[i + 2][2]));
        is_substr0[i][3] = is_substr0[i][2].or(states[i + 1][2].and(states[i + 2][3]));
        is_substr0[i][4] = is_substr0[i][3].or(states[i + 1][3].and(states[i + 2][4]));
        is_reveal0[i] = is_substr0[i][4].and(is_consecutive[i][1]);
        reveal0[i] = input[i + 1].value.mul(is_reveal0[i].toField());
    }
    reveal0.unshift(input[0].value.mul(states[1][1].toField()));
    reveal.push(reveal0);
    return { out, reveal };
}
function bodyHashRegex(input) {
    const num_bytes = input.length;
    let states = Array.from({ length: num_bytes + 1 }, () => []);
    let state_changed = Array.from({ length: num_bytes }, () => Bool(false));
    states[0][0] = Bool(true);
    for (let i = 1; i < 28; i++) {
        states[0][i] = Bool(false);
    }
    for (let i = 0; i < num_bytes; i++) {
        const lt0 = new UInt8(97).lessThanOrEqual(input[i]);
        const lt1 = input[i].lessThanOrEqual(122);
        const and0 = lt0.and(lt1);
        const and1 = states[i][1].and(and0);
        const lt2 = new UInt8(99).lessThanOrEqual(input[i]);
        const lt3 = input[i].lessThanOrEqual(122);
        const and2 = lt2.and(lt3);
        const eq0 = input[i].value.equals(97);
        let multi_or0 = Bool(false);
        multi_or0 = multi_or0.or(and2);
        multi_or0 = multi_or0.or(eq0);
        const and3 = states[i][6].and(multi_or0);
        const lt4 = new UInt8(105).lessThanOrEqual(input[i]);
        const lt5 = input[i].lessThanOrEqual(122);
        const and4 = lt4.and(lt5);
        const eq1 = input[i].value.equals(98);
        const eq2 = input[i].value.equals(99);
        const eq3 = input[i].value.equals(100);
        const eq4 = input[i].value.equals(101);
        const eq5 = input[i].value.equals(102);
        const eq6 = input[i].value.equals(103);
        let multi_or1 = Bool(false);
        multi_or1 = multi_or1.or(and4);
        multi_or1 = multi_or1.or(eq0);
        multi_or1 = multi_or1.or(eq1);
        multi_or1 = multi_or1.or(eq2);
        multi_or1 = multi_or1.or(eq3);
        multi_or1 = multi_or1.or(eq4);
        multi_or1 = multi_or1.or(eq5);
        multi_or1 = multi_or1.or(eq6);
        const and5 = states[i][8].and(multi_or1);
        const and6 = states[i][10].and(and0);
        const and7 = states[i][27].and(and0);
        let multi_or2 = Bool(false);
        multi_or2 = multi_or2.or(and1);
        multi_or2 = multi_or2.or(and3);
        multi_or2 = multi_or2.or(and5);
        multi_or2 = multi_or2.or(and6);
        multi_or2 = multi_or2.or(and7);
        states[i + 1][1] = multi_or2;
        state_changed[i] = state_changed[i].or(states[i + 1][1]);
        const eq7 = input[i].value.equals(61);
        const and8 = states[i][1].and(eq7);
        const and9 = states[i][8].and(eq7);
        let multi_or3 = Bool(false);
        multi_or3 = multi_or3.or(and8);
        multi_or3 = multi_or3.or(and9);
        states[i + 1][2] = multi_or3;
        state_changed[i] = state_changed[i].or(states[i + 1][2]);
        const eq8 = input[i].value.equals(110);
        const and10 = states[i][7].and(eq8);
        states[i + 1][3] = and10;
        state_changed[i] = state_changed[i].or(states[i + 1][3]);
        const eq9 = input[i].value.equals(59);
        const and11 = states[i][2].and(eq9.not());
        const eq10 = input[i].value.equals(43);
        const eq11 = input[i].value.equals(47);
        const eq12 = input[i].value.equals(48);
        const eq13 = input[i].value.equals(49);
        const eq14 = input[i].value.equals(50);
        const eq15 = input[i].value.equals(51);
        const eq16 = input[i].value.equals(52);
        const eq17 = input[i].value.equals(53);
        const eq18 = input[i].value.equals(54);
        const eq19 = input[i].value.equals(55);
        const eq20 = input[i].value.equals(56);
        const eq21 = input[i].value.equals(57);
        const eq22 = input[i].value.equals(65);
        const eq23 = input[i].value.equals(66);
        const eq24 = input[i].value.equals(67);
        const eq25 = input[i].value.equals(68);
        const eq26 = input[i].value.equals(69);
        const eq27 = input[i].value.equals(70);
        const eq28 = input[i].value.equals(71);
        const eq29 = input[i].value.equals(72);
        const eq30 = input[i].value.equals(73);
        const eq31 = input[i].value.equals(74);
        const eq32 = input[i].value.equals(75);
        const eq33 = input[i].value.equals(76);
        const eq34 = input[i].value.equals(77);
        const eq35 = input[i].value.equals(78);
        const eq36 = input[i].value.equals(79);
        const eq37 = input[i].value.equals(80);
        const eq38 = input[i].value.equals(81);
        const eq39 = input[i].value.equals(82);
        const eq40 = input[i].value.equals(83);
        const eq41 = input[i].value.equals(84);
        const eq42 = input[i].value.equals(85);
        const eq43 = input[i].value.equals(86);
        const eq44 = input[i].value.equals(87);
        const eq45 = input[i].value.equals(88);
        const eq46 = input[i].value.equals(89);
        const eq47 = input[i].value.equals(90);
        const eq48 = input[i].value.equals(104);
        const eq49 = input[i].value.equals(105);
        const eq50 = input[i].value.equals(106);
        const eq51 = input[i].value.equals(107);
        const eq52 = input[i].value.equals(108);
        const eq53 = input[i].value.equals(109);
        const eq54 = input[i].value.equals(111);
        const eq55 = input[i].value.equals(112);
        const eq56 = input[i].value.equals(113);
        const eq57 = input[i].value.equals(114);
        const eq58 = input[i].value.equals(115);
        const eq59 = input[i].value.equals(116);
        const eq60 = input[i].value.equals(117);
        const eq61 = input[i].value.equals(118);
        const eq62 = input[i].value.equals(119);
        const eq63 = input[i].value.equals(120);
        const eq64 = input[i].value.equals(121);
        const eq65 = input[i].value.equals(122);
        let multi_or4 = Bool(false);
        multi_or4 = multi_or4.or(eq9);
        multi_or4 = multi_or4.or(eq10);
        multi_or4 = multi_or4.or(eq11);
        multi_or4 = multi_or4.or(eq12);
        multi_or4 = multi_or4.or(eq13);
        multi_or4 = multi_or4.or(eq14);
        multi_or4 = multi_or4.or(eq15);
        multi_or4 = multi_or4.or(eq16);
        multi_or4 = multi_or4.or(eq17);
        multi_or4 = multi_or4.or(eq18);
        multi_or4 = multi_or4.or(eq19);
        multi_or4 = multi_or4.or(eq20);
        multi_or4 = multi_or4.or(eq21);
        multi_or4 = multi_or4.or(eq7);
        multi_or4 = multi_or4.or(eq22);
        multi_or4 = multi_or4.or(eq23);
        multi_or4 = multi_or4.or(eq24);
        multi_or4 = multi_or4.or(eq25);
        multi_or4 = multi_or4.or(eq26);
        multi_or4 = multi_or4.or(eq27);
        multi_or4 = multi_or4.or(eq28);
        multi_or4 = multi_or4.or(eq29);
        multi_or4 = multi_or4.or(eq30);
        multi_or4 = multi_or4.or(eq31);
        multi_or4 = multi_or4.or(eq32);
        multi_or4 = multi_or4.or(eq33);
        multi_or4 = multi_or4.or(eq34);
        multi_or4 = multi_or4.or(eq35);
        multi_or4 = multi_or4.or(eq36);
        multi_or4 = multi_or4.or(eq37);
        multi_or4 = multi_or4.or(eq38);
        multi_or4 = multi_or4.or(eq39);
        multi_or4 = multi_or4.or(eq40);
        multi_or4 = multi_or4.or(eq41);
        multi_or4 = multi_or4.or(eq42);
        multi_or4 = multi_or4.or(eq43);
        multi_or4 = multi_or4.or(eq44);
        multi_or4 = multi_or4.or(eq45);
        multi_or4 = multi_or4.or(eq46);
        multi_or4 = multi_or4.or(eq47);
        multi_or4 = multi_or4.or(eq0);
        multi_or4 = multi_or4.or(eq1);
        multi_or4 = multi_or4.or(eq2);
        multi_or4 = multi_or4.or(eq3);
        multi_or4 = multi_or4.or(eq4);
        multi_or4 = multi_or4.or(eq5);
        multi_or4 = multi_or4.or(eq6);
        multi_or4 = multi_or4.or(eq48);
        multi_or4 = multi_or4.or(eq49);
        multi_or4 = multi_or4.or(eq50);
        multi_or4 = multi_or4.or(eq51);
        multi_or4 = multi_or4.or(eq52);
        multi_or4 = multi_or4.or(eq53);
        multi_or4 = multi_or4.or(eq8);
        multi_or4 = multi_or4.or(eq54);
        multi_or4 = multi_or4.or(eq55);
        multi_or4 = multi_or4.or(eq56);
        multi_or4 = multi_or4.or(eq57);
        multi_or4 = multi_or4.or(eq58);
        multi_or4 = multi_or4.or(eq59);
        multi_or4 = multi_or4.or(eq60);
        multi_or4 = multi_or4.or(eq61);
        multi_or4 = multi_or4.or(eq62);
        multi_or4 = multi_or4.or(eq63);
        multi_or4 = multi_or4.or(eq64);
        multi_or4 = multi_or4.or(eq65);
        const and12 = states[i][11].and(multi_or4.not());
        let multi_or5 = Bool(false);
        multi_or5 = multi_or5.or(and11);
        multi_or5 = multi_or5.or(and12);
        states[i + 1][4] = multi_or5;
        state_changed[i] = state_changed[i].or(states[i + 1][4]);
        const and13 = states[i][4].and(eq9);
        const and14 = states[i][5].and(eq9);
        let multi_or6 = Bool(false);
        multi_or6 = multi_or6.or(and13);
        multi_or6 = multi_or6.or(and14);
        states[i + 1][5] = multi_or6;
        state_changed[i] = state_changed[i].or(states[i + 1][5]);
        const eq66 = input[i].value.equals(32);
        const and15 = states[i][5].and(eq66);
        states[i + 1][6] = and15;
        state_changed[i] = state_changed[i].or(states[i + 1][6]);
        const and16 = states[i][0].and(eq57);
        const and17 = states[i][3].and(eq57);
        let multi_or7 = Bool(false);
        multi_or7 = multi_or7.or(and16);
        multi_or7 = multi_or7.or(and17);
        states[i + 1][7] = multi_or7;
        state_changed[i] = state_changed[i].or(states[i + 1][7]);
        const and18 = states[i][6].and(eq1);
        states[i + 1][8] = and18;
        state_changed[i] = state_changed[i].or(states[i + 1][8]);
        const and19 = states[i][3].and(eq3);
        states[i + 1][9] = and19;
        state_changed[i] = state_changed[i].or(states[i + 1][9]);
        const and20 = states[i][8].and(eq48);
        states[i + 1][10] = and20;
        state_changed[i] = state_changed[i].or(states[i + 1][10]);
        const and21 = states[i][10].and(eq7);
        states[i + 1][11] = and21;
        state_changed[i] = state_changed[i].or(states[i + 1][11]);
        const lt6 = new UInt8(65).lessThanOrEqual(input[i]);
        const lt7 = input[i].lessThanOrEqual(90);
        const and22 = lt6.and(lt7);
        let multi_or8 = Bool(false);
        multi_or8 = multi_or8.or(and22);
        multi_or8 = multi_or8.or(and0);
        multi_or8 = multi_or8.or(eq10);
        multi_or8 = multi_or8.or(eq11);
        multi_or8 = multi_or8.or(eq12);
        multi_or8 = multi_or8.or(eq13);
        multi_or8 = multi_or8.or(eq14);
        multi_or8 = multi_or8.or(eq15);
        multi_or8 = multi_or8.or(eq16);
        multi_or8 = multi_or8.or(eq17);
        multi_or8 = multi_or8.or(eq18);
        multi_or8 = multi_or8.or(eq19);
        multi_or8 = multi_or8.or(eq20);
        multi_or8 = multi_or8.or(eq21);
        multi_or8 = multi_or8.or(eq7);
        const and23 = states[i][11].and(multi_or8);
        const and24 = states[i][12].and(multi_or8);
        let multi_or9 = Bool(false);
        multi_or9 = multi_or9.or(and23);
        multi_or9 = multi_or9.or(and24);
        states[i + 1][12] = multi_or9;
        state_changed[i] = state_changed[i].or(states[i + 1][12]);
        const and25 = states[i][9].and(eq51);
        states[i + 1][13] = and25;
        state_changed[i] = state_changed[i].or(states[i + 1][13]);
        const and26 = states[i][13].and(eq49);
        states[i + 1][14] = and26;
        state_changed[i] = state_changed[i].or(states[i + 1][14]);
        const and27 = states[i][14].and(eq53);
        states[i + 1][15] = and27;
        state_changed[i] = state_changed[i].or(states[i + 1][15]);
        const and28 = states[i][12].and(eq9);
        states[i + 1][16] = and28;
        state_changed[i] = state_changed[i].or(states[i + 1][16]);
        const eq67 = input[i].value.equals(45);
        const and29 = states[i][15].and(eq67);
        states[i + 1][17] = and29;
        state_changed[i] = state_changed[i].or(states[i + 1][17]);
        const and30 = states[i][17].and(eq58);
        states[i + 1][18] = and30;
        state_changed[i] = state_changed[i].or(states[i + 1][18]);
        const and31 = states[i][18].and(eq49);
        states[i + 1][19] = and31;
        state_changed[i] = state_changed[i].or(states[i + 1][19]);
        const and32 = states[i][19].and(eq6);
        states[i + 1][20] = and32;
        state_changed[i] = state_changed[i].or(states[i + 1][20]);
        const and33 = states[i][20].and(eq8);
        states[i + 1][21] = and33;
        state_changed[i] = state_changed[i].or(states[i + 1][21]);
        const and34 = states[i][21].and(eq0);
        states[i + 1][22] = and34;
        state_changed[i] = state_changed[i].or(states[i + 1][22]);
        const and35 = states[i][22].and(eq59);
        states[i + 1][23] = and35;
        state_changed[i] = state_changed[i].or(states[i + 1][23]);
        const and36 = states[i][23].and(eq60);
        states[i + 1][24] = and36;
        state_changed[i] = state_changed[i].or(states[i + 1][24]);
        const and37 = states[i][24].and(eq57);
        states[i + 1][25] = and37;
        state_changed[i] = state_changed[i].or(states[i + 1][25]);
        const and38 = states[i][25].and(eq4);
        states[i + 1][26] = and38;
        state_changed[i] = state_changed[i].or(states[i + 1][26]);
        const eq68 = input[i].value.equals(58);
        const and39 = states[i][26].and(eq68);
        states[i + 1][27] = and39;
        state_changed[i] = state_changed[i].or(states[i + 1][27]);
        states[i + 1][0] = state_changed[i].not();
    }
    let final_state_result = Bool(false);
    for (let i = 0; i <= num_bytes; i++) {
        final_state_result = final_state_result.or(states[i][16]);
    }
    const out = final_state_result;
    const msg_bytes = num_bytes - 1;
    const is_consecutive = Array.from({ length: num_bytes }, () => []);
    is_consecutive[msg_bytes][1] = Bool(true);
    for (let i = 0; i < msg_bytes; i++) {
        is_consecutive[msg_bytes - 1 - i][0] = states[num_bytes - i][16]
            .and(is_consecutive[msg_bytes - i][1].not())
            .or(is_consecutive[msg_bytes - i][1]);
        is_consecutive[msg_bytes - 1 - i][1] = state_changed[msg_bytes - i].and(is_consecutive[msg_bytes - 1 - i][0]);
    }
    // revealed transitions: [[[11,12],[12,12]]]
    let reveal = [];
    // the 0-th substring transitions: [[11,12],[12,12]]
    const is_reveal0 = [];
    let is_substr0 = Array.from({ length: msg_bytes }, () => []);
    const reveal0 = [];
    for (let i = 0; i < msg_bytes - 1; i++) {
        is_substr0[i][0] = Bool(false);
        is_substr0[i][1] = is_substr0[i][0].or(states[i + 1][11].and(states[i + 2][12]));
        is_substr0[i][2] = is_substr0[i][1].or(states[i + 1][12].and(states[i + 2][12]));
        is_reveal0[i] = is_substr0[i][2].and(is_consecutive[i][1]);
        reveal0[i] = input[i + 1].value.mul(is_reveal0[i].toField());
    }
    reveal.push(reveal0);
    return { out, reveal };
}
function bodyHashRegex2(input) {
    const num_bytes = input.length;
    let states = Array.from({ length: num_bytes + 1 }, () => []);
    let state_changed = Array.from({ length: num_bytes }, () => Bool(false));
    states[0][0] = Bool(true);
    for (let i = 1; i < 6; i++) {
        states[0][i] = Bool(false);
    }
    for (let i = 0; i < num_bytes; i++) {
        const lt0 = new UInt8(65).lessThanOrEqual(input[i]);
        const lt1 = input[i].lessThanOrEqual(90);
        const and0 = lt0.and(lt1);
        const lt2 = new UInt8(97).lessThanOrEqual(input[i]);
        const lt3 = input[i].lessThanOrEqual(122);
        const and1 = lt2.and(lt3);
        const eq0 = input[i].value.equals(43);
        const eq1 = input[i].value.equals(47);
        const eq2 = input[i].value.equals(48);
        const eq3 = input[i].value.equals(49);
        const eq4 = input[i].value.equals(50);
        const eq5 = input[i].value.equals(51);
        const eq6 = input[i].value.equals(52);
        const eq7 = input[i].value.equals(53);
        const eq8 = input[i].value.equals(54);
        const eq9 = input[i].value.equals(55);
        const eq10 = input[i].value.equals(56);
        const eq11 = input[i].value.equals(57);
        const eq12 = input[i].value.equals(61);
        let multi_or0 = Bool(false);
        multi_or0 = multi_or0.or(and0);
        multi_or0 = multi_or0.or(and1);
        multi_or0 = multi_or0.or(eq0);
        multi_or0 = multi_or0.or(eq1);
        multi_or0 = multi_or0.or(eq2);
        multi_or0 = multi_or0.or(eq3);
        multi_or0 = multi_or0.or(eq4);
        multi_or0 = multi_or0.or(eq5);
        multi_or0 = multi_or0.or(eq6);
        multi_or0 = multi_or0.or(eq7);
        multi_or0 = multi_or0.or(eq8);
        multi_or0 = multi_or0.or(eq9);
        multi_or0 = multi_or0.or(eq10);
        multi_or0 = multi_or0.or(eq11);
        multi_or0 = multi_or0.or(eq12);
        const and2 = states[i][1].and(multi_or0);
        const and3 = states[i][5].and(multi_or0);
        let multi_or1 = Bool(false);
        multi_or1 = multi_or1.or(and2);
        multi_or1 = multi_or1.or(and3);
        states[i + 1][1] = multi_or1;
        state_changed[i] = state_changed[i].or(states[i + 1][1]);
        const eq13 = input[i].value.equals(98);
        const and4 = states[i][0].and(eq13);
        states[i + 1][2] = and4;
        state_changed[i] = state_changed[i].or(states[i + 1][2]);
        const eq14 = input[i].value.equals(104);
        const and5 = states[i][2].and(eq14);
        states[i + 1][3] = and5;
        state_changed[i] = state_changed[i].or(states[i + 1][3]);
        const eq15 = input[i].value.equals(59);
        const and6 = states[i][1].and(eq15);
        states[i + 1][4] = and6;
        state_changed[i] = state_changed[i].or(states[i + 1][4]);
        const and7 = states[i][3].and(eq12);
        states[i + 1][5] = and7;
        state_changed[i] = state_changed[i].or(states[i + 1][5]);
        states[i + 1][0] = state_changed[i].not();
    }
    let final_state_result = Bool(false);
    for (let i = 0; i <= num_bytes; i++) {
        final_state_result = final_state_result.or(states[i][4]);
    }
    const out = final_state_result;
    const msg_bytes = num_bytes - 1;
    const is_consecutive = Array.from({ length: num_bytes }, () => []);
    is_consecutive[msg_bytes][1] = Bool(true);
    for (let i = 0; i < msg_bytes; i++) {
        is_consecutive[msg_bytes - 1 - i][0] = states[num_bytes - i][4]
            .and(is_consecutive[msg_bytes - i][1].not())
            .or(is_consecutive[msg_bytes - i][1]);
        is_consecutive[msg_bytes - 1 - i][1] = state_changed[msg_bytes - i].and(is_consecutive[msg_bytes - 1 - i][0]);
    }
    // revealed transitions: [[[5,1],[1,1]]]
    let reveal = [];
    // the 0-th substring transitions: [[5,1],[1,1]]
    const is_reveal0 = [];
    let is_substr0 = Array.from({ length: msg_bytes }, () => []);
    const reveal0 = [];
    for (let i = 0; i < msg_bytes - 1; i++) {
        is_substr0[i][0] = Bool(false);
        is_substr0[i][1] = is_substr0[i][0].or(states[i + 1][5].and(states[i + 2][1]));
        is_substr0[i][2] = is_substr0[i][1].or(states[i + 1][1].and(states[i + 2][1]));
        is_reveal0[i] = is_substr0[i][2].and(is_consecutive[i][1]);
        reveal0[i] = input[i + 1].value.mul(is_reveal0[i].toField());
    }
    reveal.push(reveal0);
    return { out, reveal };
}
//# sourceMappingURL=zkapp.js.map